{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}

Program BERMUDA_TRIANGLE;

type realno=real;
     coordarray=array[1..8001] of realno;
     indexarray=array[1..8001] of integer;

const filein='TRI.IN';
      fileout='TRI.OUT';
      eps:realno=1e-6;
      lat:array[1..3,1..2] of byte=((1,2),(1,3),(2,3));
      pivot:array[1..3] of byte=(2,3,3);
      right:array[1..3] of byte=(2,3,1);

var fin,fout:text;
    xt,yt:array[1..4] of longint;
    at,bt,ct:array[1..4] of longint;
    i,j,k,m,n,p,q,nint,oo,nright:integer;
    xint,yint:array[1..2] of realno;
    seg:array[1..2] of byte;
    x1,y1,x2,y2,dist,dpivot,daux,dpaux:^coordarray;
    ind,indaux:^indexarray;
    edge:array[1..8001,1..2] of byte;
    xx1,yy1,xx2,yy2,aa,bb,cc,vv:longint;
    xi,yi:realno;

procedure sortd(li,ls:integer);
begin
if (ls-li=1) then
  begin
    if (dist^[li]>dist^[ls]) then
      begin
        xi:=dist^[li];
        dist^[li]:=dist^[ls];
        dist^[ls]:=xi;

        xi:=dpivot^[li];
        dpivot^[li]:=dpivot^[ls];
        dpivot^[ls]:=xi;
      end;
  end
else
  if (ls-li>1) then
    begin
      sortd(li,(li+ls) shr 1);
      sortd((li+ls) shr 1 +1,ls);

      k:=li-1;
      i:=li;
      m:=(li+ls) shr 1;
      j:=m+1;

      while (i<=m) and (j<=ls) do
        begin
          inc(k);
          if (dist^[i]<dist^[j]) then
            begin
              daux^[k]:=dist^[i];
              dpaux^[k]:=dpivot^[i];
              inc(i);
            end
          else
            begin
              daux^[k]:=dist^[j];
              dpaux^[k]:=dpivot^[j];
              inc(j);
            end;
        end;

      if (i<=m) then
        begin
          for j:=i to m do
            begin
              inc(k);
              daux^[k]:=dist^[j];
              dpaux^[k]:=dpivot^[j];
            end;
        end
      else
        begin
          for i:=j to ls do
            begin
              inc(k);
              daux^[k]:=dist^[i];
              dpaux^[k]:=dpivot^[i];
            end;
        end;

      for k:=li to ls do
        begin
          dist^[k]:=daux^[k];
          dpivot^[k]:=dpaux^[k];
        end;

    end;
end;

procedure calcinv(li,ls:integer);
begin
if (ls-li=1) then
  begin
    if (dpivot^[li]<dpivot^[ls]) then
      begin
        inc(nint);

        xi:=dpivot^[li];
        dpivot^[li]:=dpivot^[ls];
        dpivot^[ls]:=xi;
      end;
  end
else
  if (ls-li>1) then
    begin
      calcinv(li,(li+ls) shr 1);
      calcinv((li+ls) shr 1 +1,ls);

      k:=li-1;
      i:=li;
      m:=(li+ls) shr 1;
      j:=m+1;

      while (i<=m) and (j<=ls) do
        begin
          inc(k);
          if (dpivot^[i]>dpivot^[j]) then
            begin
              daux^[k]:=dpivot^[i];
              inc(i);
            end
          else
            begin
              daux^[k]:=dpivot^[j];

              nint:=nint+(m-i+1);

              inc(j);
            end;
        end;

      if (i<=m) then
        begin
          for j:=i to m do
            begin
              inc(k);
              daux^[k]:=dpivot^[j];
            end;
        end
      else
        begin
          for i:=j to m do
            begin
              inc(k);
              daux^[k]:=dpivot^[j];
            end;
        end;

      for k:=li to ls do
        dpivot^[k]:=daux^[k];

    end;
end;

procedure sorti(li,ls:integer);
begin
if (ls-li=1) then
  begin
    if (dist^[li]>dist^[ls]) then
      begin
        xi:=dist^[li];
        dist^[li]:=dist^[ls];
        dist^[ls]:=xi;

        vv:=ind^[li];
        ind^[li]:=ind^[ls];
        ind^[ls]:=vv;
      end;
  end
else
  if (ls-li>1) then
    begin
      sorti(li,(li+ls) shr 1);
      sorti((li+ls) shr 1 +1,ls);

      k:=li-1;
      i:=li;
      m:=(li+ls) shr 1;
      j:=m+1;

      while (i<=m) and (j<=ls) do
        begin
          inc(k);
          if (dist^[i]<dist^[j]) then
            begin
              daux^[k]:=dist^[i];
              indaux^[k]:=ind^[i];
              inc(i);
            end
          else
            begin
              daux^[k]:=dist^[j];
              indaux^[k]:=ind^[j];
              inc(j);
            end;
        end;

      if (i<=m) then
        begin
          for j:=i to m do
            begin
              inc(k);
              daux^[k]:=dist^[j];
              indaux^[k]:=ind^[j];
            end;
        end
      else
        begin
          for i:=j to ls do
            begin
              inc(k);
              daux^[k]:=dist^[i];
              indaux^[k]:=ind^[i];
            end;
        end;

      for k:=li to ls do
        begin
          dist^[k]:=daux^[k];
          ind^[k]:=indaux^[k];
        end;

    end;
end;



begin
assign(fin,filein);
reset(fin);

for i:=1 to 3 do
  readln(fin,xt[i],yt[i]);

xt[4]:=xt[1];
yt[4]:=yt[1];

for i:=1 to 3 do
  begin
    at[i]:=yt[i]-yt[i+1];
    bt[i]:=xt[i+1]-xt[i];
    ct[i]:=xt[i]*yt[i+1]-xt[i+1]*yt[i];
  end;

readln(fin,n);


new(x1); fillchar(x1^,sizeof(x1^),0);
new(y1); fillchar(y1^,sizeof(y1^),0);
new(x2); fillchar(x2^,sizeof(x2^),0);
new(y2); fillchar(y2^,sizeof(y2^),0);

p:=0;
for k:=1 to n do
  begin
    readln(fin,xx1,yy1,xx2,yy2);

    aa:=yy1-yy2;
    bb:=xx2-xx1;
    cc:=xx1*yy2-xx2*yy1;

    nint:=0;
    for i:=1 to 3 do
      begin
        vv:=(aa*bt[i]-at[i]*bb);

        if (vv<>0) then
          begin

            xi:=(bb*ct[i]-bt[i]*cc)/vv;
            yi:=(cc*at[i]-ct[i]*aa)/vv;

            if (
               (
               (
               ((xi>=xx1) or (abs(xi-xx1)<eps)) and
               ((xi<=xx2) or (abs(xi-xx2)<eps))
               ) or
               (
               ((xi>=xx2) or (abs(xi-xx2)<eps)) and
               ((xi<=xx1) or (abs(xi-xx1)<eps))
               )
               ) and
               (
               (
               ((yi>=yy1) or (abs(yi-yy1)<eps)) and
               ((yi<=yy2) or (abs(yi-yy2)<eps))
               ) or
               (
               ((yi>=yy2) or (abs(yi-yy2)<eps)) and
               ((yi<=yy1) or (abs(yi-yy1)<eps))
               )
               ) and
               (
               (
               ((xi>=xt[i]) or (abs(xi-xt[i])<eps)) and
               ((xi<=xt[i+1]) or (abs(xi-xt[i+1])<eps))
               ) or
               (
               ((xi>=xt[i+1]) or (abs(xi-xt[i+1])<eps)) and
               ((xi<=xt[i]) or (abs(xi-xt[i])<eps))
               )
               ) and
               (
               (
               ((yi>=yt[i]) or (abs(yi-yt[i])<eps)) and
               ((yi<=yt[i+1]) or (abs(yi-yt[i+1])<eps))
               ) or
               (
               ((yi>=yt[i+1]) or (abs(yi-yt[i+1])<eps)) and
               ((yi<=yt[i]) or (abs(yi-yt[i])<eps))
               )
               )
               )
            then
              begin
                inc(nint);
                xint[nint]:=xi;
                yint[nint]:=yi;
                seg[nint]:=i;
              end;

          end;
      end;

    if (nint=2) then
      begin
        inc(p);
        if (seg[1]<seg[2]) then
          begin
            x1^[p]:=xint[1]; y1^[p]:=yint[1];
            x2^[p]:=xint[2]; y2^[p]:=yint[2];
            edge[p,1]:=seg[1];
            edge[p,2]:=seg[2];
          end
        else
          begin
            x1^[p]:=xint[2]; y1^[p]:=yint[2];
            x2^[p]:=xint[1]; y2^[p]:=yint[1];
            edge[p,1]:=seg[2];
            edge[p,2]:=seg[1];
          end;
      end;
  end;
close(fin);

n:=p;
nint:=0;

new(dist); fillchar(dist^,sizeof(dist^),0);
new(dpivot); fillchar(dpivot^,sizeof(dpivot^),0);
new(daux); fillchar(daux^,sizeof(daux^),0);
new(dpaux); fillchar(dpaux^,sizeof(dpaux^),0);

for oo:=1 to 3 do
  begin

    p:=0;

    for i:=1 to n do
      if (edge[i,1]=lat[oo,1]) and
         (edge[i,2]=lat[oo,2])
      then
        begin
          inc(p);

          dist^[p]:=(x1^[i]-xt[lat[oo,1]])*
                    (x1^[i]-xt[lat[oo,1]])+
                    (y1^[i]-yt[lat[oo,1]])*
                    (y1^[i]-yt[lat[oo,1]]);

          dpivot^[p]:=(x2^[i]-xt[pivot[oo]])*
                      (x2^[i]-xt[pivot[oo]])+
                      (y2^[i]-yt[pivot[oo]])*
                      (y2^[i]-yt[pivot[oo]]);

        end;

    fillchar(daux^,sizeof(daux^),0);
    sortd(1,p);

    fillchar(daux^,sizeof(daux^),0);
    calcinv(1,p);

  end;

dispose(dpaux);
dispose(dpivot);

new(ind); fillchar(ind^,sizeof(ind^),0);
new(indaux); fillchar(indaux^,sizeof(indaux^),0);

for oo:=1 to 3 do
  begin

    p:=0;
    for i:=1 to n do
      if (edge[i,1]=oo) then
        begin
          inc(p);
          dist^[p]:=(x1^[i]-xt[oo])*
                    (x1^[i]-xt[oo])+
                    (y1^[i]-yt[oo])*
                    (y1^[i]-yt[oo]);

          ind^[p]:=edge[i,2];
        end
      else
      if (edge[i,2]=oo) then
        begin
          inc(p);
          dist^[p]:=(x2^[i]-xt[oo])*
                    (x2^[i]-xt[oo])+
                    (y2^[i]-yt[oo])*
                    (y2^[i]-yt[oo]);

          ind^[p]:=edge[i,1];
        end;

    fillchar(daux^,sizeof(daux^),0);
    fillchar(indaux^,sizeof(indaux^),0);
    sorti(1,p);

    nright:=0;

    for i:=1 to p do
      if (ind^[i]=right[oo]) then
        inc(nright)
      else
        nint:=nint+nright;

  end;

assign(fout,'TRI.OUT');
rewrite(fout);
writeln(fout,nint);
close(fout);
end.